"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ExpressTS_1 = __importDefault(require("./ExpressTS"));
exports.default = (function (method, child, middlewares) { return function (target, key, descriptor) {
    var name = target.constructor.name;
    var actionFunction = {
        name: key,
        method: method,
        child: child,
        middlewares: middlewares
    };
    var action = ExpressTS_1.default.getData(name, 'actions');
    if (!action) {
        ExpressTS_1.default.setData(name, {
            functions: [actionFunction]
        }, 'actions');
    }
    else {
        ExpressTS_1.default.setData(name, __assign(__assign({}, action), { functions: __spreadArrays(action.functions, [actionFunction]) }), 'actions');
    }
    return descriptor;
}; });
//# sourceMappingURL=defineMethod.js.map